SystemOrganization addCategory: #Sprite!


TTSampleStringMorph subclass: #TTFLiveInfo
	instanceVariableNames: 'dalpha'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sprite'!

Morph subclass: #PlayerHalo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sprite'!

PolygonMorph subclass: #SpriteTrajectory
	instanceVariableNames: 'cache offset'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'Sprite'!

IconicButton subclass: #SpriteButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sprite'!

SpriteButton class
	instanceVariableNames: ''!

PlayerHalo class
	instanceVariableNames: ''!

Object subclass: #SpriteGame
	instanceVariableNames: 'level root controls'
	classVariableNames: 'Controls Silent'
	poolDictionaries: ''
	category: 'Sprite'!

TTFLiveInfo class
	instanceVariableNames: ''!

Object subclass: #SpriteGameScores
	instanceVariableNames: 'scores'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sprite'!

PackageInfo subclass: #SpriteInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sprite'!

Object subclass: #SpriteGameLevel
	instanceVariableNames: 'nextLevel levelSelector allowHelp label code endTest skipTest endCode stats helpText uid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sprite'!

SpriteGameLevel class
	instanceVariableNames: ''!

SpriteGame class
	instanceVariableNames: 'BannerFont CustomStrikeFont Scores'!

TextMorph subclass: #LiveInfo
	instanceVariableNames: 'dalpha'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sprite'!

LiveInfo class
	instanceVariableNames: ''!

SpriteInfo class
	instanceVariableNames: ''!

PackageInfo subclass: #SpriteStandaloneInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sprite'!

SpriteStandaloneInfo class
	instanceVariableNames: ''!

SpriteTrajectory class
	instanceVariableNames: ''!

SpriteGameScores class
	instanceVariableNames: ''!

Morph subclass: #Sprite
	instanceVariableNames: 'clock action form forms nextSwapTime clockOffset scale swapInterval'
	classVariableNames: 'BlockFormHibernation FormsCache'
	poolDictionaries: ''
	category: 'Sprite'!

Sprite class
	instanceVariableNames: ''!


!Sprite commentStamp: 'spfa 3/2/2012 13:23' prior: 0!
(Sprite orbitingAround: Display center at: 100 speed: 90) openInWorld

((Sprite orbitingAround: World currentHand position at: 100 speed: 140) color: Color orange) openInWorld

Sprite pulsating openInWorld


(1 to: 100) do: [:n |
	((Sprite orbitingAround: Display center at: (2 * n) + 30 speed: (100 atRandom + 10)) color: (Color gray: n / 100.0)) openInWorld]


(1 to: 100) do: [:n |
	(Sprite pulsating color: (Color gray: n / 100.0) ; position: (1000 atRandom @ 600 atRandom)) openInWorld]

Project current fullScreenOn
!

!Number methodsFor: '*Sprite' stamp: 'spfa 7/18/2014 20:45'!
+- aNumber

	^ (self - aNumber) + ((2000 * aNumber) truncated atRandom / 1000.0)! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 9/4/2014 16:33'!
action

	^ action! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 3/2/2012 12:06'!
action: aBlock

	action _ aBlock

	
! !

!LiveInfo methodsFor: 'as yet unclassified' stamp: 'spfa 8/4/2014 11:26'!
addHalo: ignored! !

!PasteUpMorph methodsFor: '*Sprite' stamp: 'spfa 9/15/2014 11:47'!
addHalo: evt

	SpriteGame hasRunningGame ifTrue: [^ self].
	super addHalo: evt! !

!SpriteButton methodsFor: 'as yet unclassified' stamp: 'spfa 8/4/2014 11:25'!
addHalo: ignored! !

!SpriteInfo methodsFor: 'as yet unclassified' stamp: 'spfa 9/1/2014 14:16'!
additionalFiles
	"These are additional files that get extracted from the zip"
	^#()! !

!SpriteStandaloneInfo methodsFor: 'as yet unclassified' stamp: 'spfa 9/1/2014 14:16'!
additionalFiles
	"These are additional files that get extracted from the zip"
	^#()! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 9/4/2014 16:33'!
after: aNumber do: aBlock

	(aBlock future: (aNumber * 1000)) value! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
allowHelp: aBoolean

	allowHelp := aBoolean! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
allowsHelp

	^ allowHelp! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 8/2/2014 17:56'!
anyStatsContains: aSymbol

	^ (self stats includesKey: aSymbol)
		or: [nextLevel notNil and: [nextLevel anyStatsContains: aSymbol]]! !

!SpriteTrajectory class methodsFor: 'instance creation' stamp: 'spfa 8/16/2014 13:44'!
around: aPoint radius: aNumber

	| points |

	points := (1 to: 9) collect: [:n |
			aPoint + (Point r: aNumber theta: n * Float twoPi / 9)	].

	^ self vertices: points curve: true closed: true.! !

!TTGlyph methodsFor: '*Sprite' stamp: 'spfa 7/28/2014 17:38'!
asFormWithScale: scale ascender: ascender descender: descender
	^ self
		asFormWithScale: scale
		ascender: ascender
		descender: descender
		fgColor: Color black
		bgColor: Color white
		depth: 32
		replaceColor: false.
! !

!SpriteGame methodsFor: 'key bindings' stamp: 'spfa 8/21/2014 11:40'!
attributeClickKey: anEvent

	World eventHandler on: #keyStroke send: #unwantedEvent: to: self.

	(self commandAt: anEvent) ifNil: [
		self inform: 'There is no command for ', anEvent keyCharacter uppercaseName
			for: 5]

	ifNotNil: [
		(Controls ifNil: [Controls := controls]) at: #click 
			put: anEvent keyCharacter asUppercase asciiValue.
		self inform: 'Mouse click now does ', anEvent keyCharacter uppercaseName for: 5].

	self after: 1 do: [self interactivelyChangeKey]

! !

!SpriteGame methodsFor: 'key bindings' stamp: 'spfa 8/21/2014 11:39'!
attributeKey: anEvent to: aSelector

	| kVal pSel pKey |

	World eventHandler on: #keyStroke send: #unwantedEvent: to: self.

	Controls ifNil: [Controls := controls].

	kVal := anEvent keyCharacter asUppercase asciiValue.
	pSel := Controls at: kVal ifAbsent: [nil].
	pKey := Controls keyAtValue: aSelector ifAbsent: [nil].

	Controls at: kVal put: aSelector.

	self clickKey = pKey ifTrue: [Controls at: #click put: kVal].

	pKey ifNotNil: [
		pSel ifNil: [Controls removeKey: pKey]
			ifNotNil: [Controls at: pKey put: pSel]].

	self inform: 'OK for ', anEvent keyCharacter uppercaseName for: 5.

	self after: 1 do: [self interactivelyChangeKey]
! !

!SpriteGame methodsFor: 'UI' stamp: 'spfa 7/22/2014 16:11'!
bannerFont

	^ self class bannerFont
! !

!SpriteGame class methodsFor: 'as yet unclassified' stamp: 'spfa 7/22/2014 16:29'!
bannerFont

	^ BannerFont ifNil: [BannerFont := TTFontDescription default]
! !

!SpriteGame class methodsFor: 'as yet unclassified' stamp: 'spfa 7/22/2014 16:29'!
bannerFont: aTTFontDescription

	BannerFont := aTTFontDescription
! !

!SpriteGame methodsFor: 'scoring' stamp: 'spfa 7/22/2014 17:51'!
beginRecordStats! !

!Sprite class methodsFor: 'utils' stamp: 'spfa 9/12/2014 20:34'!
blockFormHibernation
	"Accessor for the system-wide preference"
	
	<preference: 'Forbid all forms to hibernate.'
		category: 'Sprite'
		description: 'If enabled, a Form or ColorForm will never hibernate; as a result the image may grow much larger, but the forms it contains will be accessed much faster.'
		type: #Boolean>
	^BlockFormHibernation ifNil: [ false ]! !

!Sprite class methodsFor: 'utils' stamp: 'spfa 9/12/2014 20:31'!
blockFormHibernation: aBoolean
	"Accessor for the system-wide preference"
	
	BlockFormHibernation := aBoolean
! !

!SpriteTrajectory methodsFor: 'sprite actions' stamp: 'spfa 8/12/2014 14:20'!
bounce: nNumber of: aSpriteSubClass speed: aNumber offset: bNumber

	1 to: nNumber do: [:i |
		self bounceSprite: (aSpriteSubClass new clockOffset: i * bNumber) speed: aNumber]! !

!SpriteTrajectory methodsFor: 'sprite actions' stamp: 'spfa 7/28/2014 14:09'!
bounceSprite: aSprite speed: aNumber

	(aSprite action: (self bouncingAtSpeed: aNumber)) openInWorld! !

!SpriteTrajectory methodsFor: 'sprite actions' stamp: 'spfa 9/4/2014 16:33'!
bouncingAtSpeed: aNumber

	"aNumber is the speed in pixels per second"

	^ [:sprite :t |
		sprite center: (self pointAtRelativePosition: 
			((t * aNumber * 0.5 /// self totalLength) fractionPart - 0.5 * 2) abs)]
! !

!SpriteTrajectory class methodsFor: 'caching' stamp: 'spfa 9/4/2014 16:33'!
cache

	^ Cache ifNil: [Cache := IdentityDictionary new]! !

!SpriteTrajectory class methodsFor: 'caching' stamp: 'spfa 9/15/2014 11:48'!
cached: aSymbol in: aClass
	
	"Note that the lookup is only on aSymbol, not on aClass."

	| woffset |

	woffset := 0@0.
	SpriteGame hasRunningGame ifTrue: [
		woffset := SpriteGame runningGame class worldOrigin].

	^ (self cache at: aSymbol ifAbsentPut: [aClass perform: aSymbol]) 
		sansOffset copy offset: woffset! !

!SpriteGame methodsFor: 'key bindings' stamp: 'spfa 8/21/2014 11:39'!
changeKey: anEvent

	World eventHandler on: #keyStroke send: #unwantedEvent: to: self.

	anEvent keyCharacter == $* ifTrue: [
		^ self write: 'Type the click key: ' onNextKeyDo: [:evt | self attributeClickKey: evt]].

	anEvent keyCharacter == self keyBindingCharacter ifTrue: [
		World eventHandler on: #keyStroke send: #keyStroke: to: self.
		^ self hideHelp; liftPause].

	anEvent keyCharacter == self keyBindingResetCharacter ifTrue: [
		Controls := nil.
		self initializeControls; inform: 'Key bindings have been reset.' for: 5.
		^ self after: 1 do: [self interactivelyChangeKey]].

	(self commandAt: anEvent) ifNil: [
		self inform: 'There is no command for ', anEvent keyCharacter uppercaseName
			for: 5.
		^ self after: 1 do: [self interactivelyChangeKey]].

	self write: 'Type a key to replace ', anEvent keyCharacter uppercaseName
		onNextKeyDo: [:evt | self attributeKey: evt to: (self commandAt: anEvent)].
! !

!SpriteTrajectory methodsFor: 'updating' stamp: 'spfa 9/4/2014 16:33'!
changed

	super changed.
	self eraseCache! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 7/18/2014 16:09'!
checkForFailure

	"subclasses should provide a test here"

	^ false! !

!Sprite class methodsFor: 'caching' stamp: 'spfa 9/4/2014 16:33'!
checkUp

	self formsCache ifEmpty: [self populateCache].

	self formsCache do: [:ea | 
		ea do: [:form | form unhibernate]]! !

!SpriteTrajectory class methodsFor: 'caching' stamp: 'spfa 9/4/2014 16:33'!
checkUp

	self cache ifEmpty: [self populateCaches]! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 9/4/2014 16:33'!
checkUpResources

	self class checkUpResources
! !

!SpriteGame class methodsFor: 'as yet unclassified' stamp: 'spfa 7/18/2014 16:30'!
checkUpResources

	"Typically, Forms may need to be unhibernated"

	Sprite checkUp.
	self checkUp.! !

!SpriteGame methodsFor: 'key bindings' stamp: 'spfa 8/19/2014 22:53'!
click: evt

	self perform: self clickCommand! !

!SpriteGame methodsFor: 'key bindings' stamp: 'spfa 8/19/2014 23:09'!
clickCommand

	^ self controls at: self clickKey! !

!SpriteGame methodsFor: 'key bindings' stamp: 'spfa 8/21/2014 10:56'!
clickKey

	^ self controls at: #click ifAbsentPut: [controls keyAtValue: self defaultClickCommand]! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 9/4/2014 16:33'!
clockOffset: seconds

	clockOffset := seconds! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
code

	^ code! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
code: aBlock

	code := aBlock! !

!SpriteGame methodsFor: 'key bindings' stamp: 'spfa 8/14/2014 12:23'!
commandAt: anEvent

	^ self controls at: anEvent keyCharacter asUppercase asciiValue ifAbsent: [^ nil]! !

!SpriteTrajectory methodsFor: 'as yet unclassified' stamp: 'spfa 7/18/2014 20:23'!
compileAs: aString

	self compileIn: self class as: aString! !

!AnimatedImageMorph methodsFor: '*Sprite' stamp: 'spfa 8/17/2014 18:25'!
compileIn: aClass as: aString

	self images doWithIndex: [:form :n |
		aClass class compile: aString, n asString, '
^ ', (form asFormOfDepth: 32) storeString 
				classified: 'forms library']! !

!Form methodsFor: '*Sprite' stamp: 'spfa 9/4/2014 16:33'!
compileIn: aClass as: aString

	aClass class compile: aString, '

	^ Form new readResourceFrom: 
		(ReadStream on: 
			''', (ByteArray streamContents: [:str | self storeResourceOn: str]) base64Encoded, ''' base64Decoded asByteArray)' classified: 'forms library'! !

!SampledSound methodsFor: '*Sprite' stamp: 'spfa 9/4/2014 16:33'!
compileIn: aClass as: aString

	aClass class compile: aString, '

	^ SampledSound new setSamples: (SoundBuffer fromArray: 
			', self samples asArray storeString , ') samplingRate: ', 
			self originalSamplingRate asString, '.' 
		classified: 'sounds library'! !

!SpriteTrajectory methodsFor: 'as yet unclassified' stamp: 'spfa 7/22/2014 17:38'!
compileIn: aClass as: aString

	aClass class compile: (aString, '

	^ ', self storeString) classified: 'trajectories library'.

	self class eraseCache! !

!SpriteTrajectory methodsFor: 'updating' stamp: 'spfa 9/4/2014 16:33'!
computePointAtRelativePosition: aFloat
	"Can take a long time if I'm curved."
	| flen length |

	aFloat <= 0 ifTrue: [^ self firstVertex].
	aFloat >= 1 ifTrue: [closed ifTrue: [] ifFalse: [^ self lastVertex]].

	flen := self totalLength asFloat.
	length := 0.
	self lineSegmentsDo: [ :a :b | 
		| dist |
		dist := (a dist: b).
		(length + dist) / flen >= aFloat ifTrue: [ | plength p |
			plength := length / flen.
			p := plength isZero ifTrue: [aFloat * flen / dist]
				ifFalse: [length * (aFloat - plength) / plength / dist].
			^a + (b - a * p)].
		length := length + dist ].
	^ closed ifTrue: [] ifFalse: [^ self lastVertex]! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 7/23/2014 18:04'!
computeScore

	| score |

	score := stats at: #time.
	nextLevel ifNil: [^ score].

	^ score + nextLevel computeScore! !

!SpriteTrajectory methodsFor: 'updating' stamp: 'spfa 9/4/2014 16:33'!
computeTotalLength

	^ super totalLength! !

!SpriteGame methodsFor: 'key bindings' stamp: 'spfa 8/14/2014 12:13'!
controls

	^ Controls ifNil: [controls]! !

!SpriteGame class methodsFor: 'as yet unclassified' stamp: 'spfa 8/14/2014 10:49'!
controls

	^ Controls! !

!SpriteGame methodsFor: 'UI' stamp: 'spfa 8/2/2014 17:19'!
counterOn: anObject selector: aSymbol color: aColor

	^ (MPEGSubtitlesDisplayer on: anObject selector: aSymbol)
			contents: '';
			font: self class strikeFont30;
			stepTime: 100;
		backgroundColor: Color transparent;
		color: aColor;
		borderWidth: 0;
		lock: true;
		yourself.! !

!SpriteGame methodsFor: 'UI' stamp: 'spfa 9/20/2014 10:15'!
credits

	^ ''! !

!SpriteGame methodsFor: 'UI' stamp: 'spfa 9/20/2014 11:22'!
creditsExtent

	^ World extent - (350@250)! !

!Sprite class methodsFor: 'utils' stamp: 'spfa 9/15/2014 11:49'!
currentGame

	^ SpriteGame runningGame! !

!Sprite methodsFor: 'private' stamp: 'spfa 8/17/2014 13:59'!
currentGame

	^ self class currentGame! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 8/12/2014 16:29'!
currentLevel

	^ level! !

!Sprite class methodsFor: 'utils' stamp: 'spfa 8/11/2014 00:33'!
cut: aForm in: aNumber extents: aPoint to: aClass as: aString classified: cString

	self cut: aForm in: aNumber from: 1 extents: aPoint to: aClass as: aString classified: cString! !

!Sprite class methodsFor: 'utils' stamp: 'spfa 9/14/2014 18:25'!
cut: aForm in: aNumber from: bNumber extents: aPoint to: aClass as: aString classified: cString

	| n nw nh w h |
	n := (bNumber - 1) negated.
	nw := (aForm width / (w := aPoint x)) rounded.
	nh := (aForm height / (h := aPoint y)) rounded.

	0 to: nh-1 do: [:j |
		0 to: nw-1 do: [:i |
			n := n + 1.
			n > aNumber ifTrue: [^ self].
			n > 0 ifTrue: [
			aClass 
				compile: aString, n asString, '
^ ', ((aForm contentsOfArea: ((i * w)@(j * h) corner: ((i + 1) * w)@((j +1) * h))) 
		asFormOfDepth: 32) storeString 
				classified: cString]]]! !

!SpriteGame methodsFor: 'key bindings' stamp: 'spfa 8/21/2014 10:57'!
defaultClickCommand

	^ #yourself! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 9/2/2014 09:56'!
defaultSwapDelay

	^ 100
	
	
! !

!SpriteGame methodsFor: 'UI' stamp: 'spfa 9/20/2014 10:49'!
displayCredits

	| font |

	self hideHelp ifTrue: [^ self].
	self credits ifEmpty: [^ self].

	font := self class strikeFont30.

	(TextMorph new contents: self credits)
		backgroundColor: (Color grey alpha: 0.3); 
		color: Color green; 
		font: font;
		autoFit: false;
		wrapFlag: true;
		extent: self creditsExtent ;
		center: World center;
		lock: true;
		getProperty: #gameHelp;
		openInWorld! !

!SpriteGame methodsFor: 'UI' stamp: 'spfa 8/14/2014 12:42'!
displayHelp: aString

	| len font |

	self hideHelp ifTrue: [^ self].
	aString ifEmpty: [^ self].

	len := 0.
	aString linesDo: [:ea | len := len max: ea size].

	font := self class strikeFont20.

	(TextMorph new contents: aString)
		backgroundColor: (Color grey alpha: 0.3); color: Color green; 
		font: font;
		setProperty: #autoFitContents toValue: false;
		width: (font widthOf: $m) * len;
		topRight: World topRight;
		lock: true;
		getProperty: #gameHelp;
		openInWorld! !

!PlayerHalo methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
drawOn: aCanvas 

	aCanvas fillOval: (self fullBounds expandBy: 30) fillStyle: (Color turquoise alpha: 0.1) borderWidth: 0 borderColor: Color grey
! !

!Sprite methodsFor: 'drawing' stamp: 'spfa 9/14/2014 23:40'!
drawOn: aCanvas

	form ifNil: [^ super drawOn: aCanvas].
	aCanvas translucentImage: form at: self fullBounds origin! !

!SpriteTrajectory methodsFor: 'editing' stamp: 'spfa 7/18/2014 17:21'!
edit

	self addHandles openInWorld.
	self inspect "use #compileIn:as: to store the edited trajectory"
	
! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
enLabel: aString

	label := aString! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
endCode

	^ endCode! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
endCode: aBlock

	endCode := aBlock! !

!SpriteGame methodsFor: 'scoring' stamp: 'spfa 7/23/2014 17:40'!
endRecordStats

! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
endTest

	^ endTest! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
endTest: aBlock

	endTest := aBlock! !

!Sprite class methodsFor: 'caching' stamp: 'spfa 9/4/2014 16:33'!
eraseCache

	FormsCache := IdentityDictionary new! !

!SpriteTrajectory methodsFor: 'updating' stamp: 'spfa 9/4/2014 16:33'!
eraseCache

	cache := IdentityDictionary new! !

!SpriteTrajectory class methodsFor: 'caching' stamp: 'spfa 9/4/2014 16:33'!
eraseCache

	Cache := IdentityDictionary new! !

!SpriteGame class methodsFor: 'as yet unclassified' stamp: 'spfa 8/15/2014 12:20'!
eraseScores

	Scores := nil! !

!SpriteGame class methodsFor: 'as yet unclassified' stamp: 'spfa 7/23/2014 15:51'!
eraseStrikeFonts

	CustomStrikeFont := IdentityDictionary new
! !

!TTFLiveInfo methodsFor: 'as yet unclassified' stamp: 'spfa 8/15/2014 12:09'!
extentHeight: aNumber

	self extent: (self extent * aNumber /// (self transform transformRect: self font bounds) height * 1.5)
! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 9/15/2014 00:23'!
fadeOut

	| t0 fadeTime iniScale |

	self getProperty: #invulnerable.

	fadeTime := 0.8.
	t0 := self timeNowWithOffset.
	iniScale := scale ifNil: [1.0].

	self action: [:sprite :t |
		| rect |
		rect := sprite fullBounds.
		(form isNil or: [rect area <= 16])
			ifTrue: [sprite delete]
			ifFalse: [scale := iniScale * (fadeTime - (t - t0)) / fadeTime].
		World invalidRect: (rect expandBy: 50) from: World.]
! !

!SpriteTrajectory methodsFor: 'sprite actions' stamp: 'spfa 9/4/2014 16:33'!
followingAtSpeed: aNumber

	"aNumber is the speed in pixels per second"
	
	| t0 |

	^ [:sprite :t |
		| dp |
		t0 ifNil: [t0 := t].
		dp := (t - t0) * aNumber /// self totalLength.
		dp > 1 ifTrue: [sprite delete].
		sprite center: dp]
! !

!SpriteTrajectory methodsFor: 'sprite actions' stamp: 'spfa 9/4/2014 16:33'!
followingMouseX

	^ self followingMouseXFrom: World left to: World right
! !

!SpriteTrajectory methodsFor: 'sprite actions' stamp: 'spfa 9/4/2014 16:33'!
followingMouseXFrom: aNumber to: bNumber

	^ [:sprite :t |
		sprite center: (self pointAtRelativePosition: 
			World currentHand position x - aNumber /// (bNumber - aNumber))]! !

!SpriteTrajectory methodsFor: 'sprite actions' stamp: 'spfa 9/4/2014 16:33'!
followingMouseY

	^ self followingMouseYFrom: World top to: World bottom
! !

!SpriteTrajectory methodsFor: 'sprite actions' stamp: 'spfa 9/4/2014 16:33'!
followingMouseYFrom: aNumber to: bNumber

	^ [:sprite :t |
		sprite center: (self pointAtRelativePosition: 
			World currentHand position y - aNumber /// (bNumber - aNumber))]! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 9/4/2014 16:33'!
form

	^ form! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 9/14/2014 23:55'!
form: aForm

	| center fxt |

	form := aForm.
	scale ifNotNil: [form := form magnifySpriteBy: scale].
	fxt := form extent.

	owner ifNil: [bounds := (bounds topLeft extent: fxt)]
		ifNotNil: [
			self extent = fxt ifFalse: [
				center := self center.
				bounds := (bounds topLeft extent: fxt).
				self center: center]].

	self changed! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 9/4/2014 16:33'!
forms: anArray

	forms := anArray cyclicGenerator.
	self form: forms next! !

!Sprite class methodsFor: 'caching' stamp: 'spfa 9/4/2014 16:33'!
formsCache

	^ FormsCache ifNil: [FormsCache := IdentityDictionary new]! !

!Sprite class methodsFor: 'caching' stamp: 'spfa 9/14/2014 18:24'!
formsRoot: aSymbol in: aClass

	^ self formsCache at: aSymbol ifAbsentPut: [
		((aClass class selectors select: [:s | s withoutTrailingDigits = aSymbol]) 
			sortBy: [:s1 :s2 | s1 asInteger < s2 asInteger])
				collect: [:ea | aClass perform: ea]]! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 9/4/2014 16:33'!
formsRoot: aSymbol in: aClass

	self forms: (self class formsRoot: aSymbol in: aClass)! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 8/12/2014 14:07'!
formsRoot: aSymbol in: aClass scale: aNumber

	scale := aNumber.
	self formsRoot: aSymbol in: aClass! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 9/14/2014 17:28'!
formsRoot: aSymbol in: aClass scale: aNumber reversed: aBoolean

	| fs |

	scale := aNumber.
	fs := self class formsRoot: aSymbol in: aClass.
	aBoolean ifTrue: [fs := fs reverse].
	self forms: fs! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
frLabel: aString

	"label := aString"! !

!Sprite methodsFor: 'private' stamp: 'spfa 9/4/2014 16:33'!
fullBounds

	^ bounds! !

!Sprite methodsFor: 'private' stamp: 'spfa 9/4/2014 16:33'!
fullDrawOn: aCanvas
	"Draw the full Morphic structure on the given Canvas"

	self visible ifFalse: [^ self].
	(aCanvas isVisible: self fullBounds) ifFalse:[^self].
	(self hasProperty: #errorOnDraw) ifTrue:[^self drawErrorOn: aCanvas].
	"Note: At some point we should generalize this into some sort of 
	multi-canvas so that we can cross-optimize some drawing operations."
	"Pass 1: Draw eventual drop-shadow"
	self hasDropShadow ifTrue: [self drawDropShadowOn: aCanvas].
	(self hasRolloverBorder and: [(aCanvas seesNothingOutside: self bounds) not])
		ifTrue: [self drawRolloverBorderOn: aCanvas].

	"Pass 2: Draw receiver itself"
	aCanvas roundCornersOf: self during:[
		self drawSubmorphsOn: aCanvas.
		(aCanvas isVisible: self bounds) ifTrue:[aCanvas drawMorph: self].
		self drawDropHighlightOn: aCanvas.
		self drawMouseDownHighlightOn: aCanvas].
! !

!SpriteGame methodsFor: 'scoring' stamp: 'spfa 8/16/2014 11:24'!
getPlayerName: aString forScore: score

	| pname |

	pname := aString.

	self write: 'Your name: ', pname
		onNextKeyDo: [:evt | 
			evt keyValue caseOf: {
				[13] -> [self registerScore: score at: pname].
				[27] -> [World eventHandler on: #keyStroke send: #keyStroke: to: self.
						self showHallOfFame].
			} otherwise: [
				evt keyValue == 8 & pname notEmpty 
					ifTrue: [pname := pname allButLast].
				evt keyCharacter isAlphaNumeric & (pname size < 12)
					ifTrue: [pname := pname, evt keyCharacter].
				self getPlayerName: pname forScore: score]]! !

!SpriteGame methodsFor: 'scoring' stamp: 'spfa 8/15/2014 11:23'!
getPlayerNameForScore: score

	self inform: 'You enter the Hall Of Fame !!'
		for: 15 height: 40 color: Color yellow borderColor: Color red
		offset: 0@ -8 * 40.

	self getPlayerName: '' forScore: score! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 9/4/2014 16:33'!
growsAtBirth

	^ false! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 9/4/2014 16:33'!
growthRate

	^ 1! !

!SpriteGame class methodsFor: 'as yet unclassified' stamp: 'spfa 9/15/2014 11:46'!
hasRunningGame

	^ Smalltalk includesKey: #RunningSpriteGame! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 8/12/2014 17:37'!
help

	^ helpText! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 8/12/2014 17:37'!
help: aString

	helpText := aString! !

!Form methodsFor: '*Sprite' stamp: 'spfa 9/12/2014 20:32'!
hibernate

	Sprite blockFormHibernation ifTrue: [^ self].
	self hibernateForGood! !

!ColorForm methodsFor: '*Sprite' stamp: 'spfa 9/12/2014 20:24'!
hibernateForGood
	"Make myself take up less space. See comment in Form>hibernateForGood."

	super hibernateForGood.
	self clearColormapCache.
	colors ifNotNil:[colors := colors asColorArray].! !

!Form methodsFor: '*Sprite' stamp: 'spfa 9/12/2014 20:23'!
hibernateForGood
	"Replace my bitmap with a compactly encoded representation (a ByteArray).  It is vital that BitBlt and any other access to the bitmap (such as writing to a file) not be used when in this state.  Since BitBlt will fail if the bitmap size is wrong (not = bitsSize), we do not allow replacement by a byteArray of the same (or larger) size."

	"NOTE: This method copies code from Bitmap compressToByteArray so that it can
	nil out the old bits during the copy, thus avoiding 2x need for extra storage."
	| compactBits lastByte |
	(bits isMemberOf: Bitmap) ifFalse: [^ self  "already hibernated or weird state"].
	compactBits := ByteArray new: (bits size*4) + 7 + (bits size//1984*3).
	lastByte := bits compress: bits toByteArray: compactBits.
	lastByte < (bits size*4) ifTrue:
		[bits := nil.  "Let GC reclaim the old bits before the copy if necessary"
		bits := compactBits copyFrom: 1 to: lastByte]
! !

!SpriteGame methodsFor: 'UI' stamp: 'spfa 8/14/2014 12:41'!
hideHelp

	World submorphsDo: [:ea | 
		(ea visible and: [ea hasProperty: #gameHelp]) ifTrue: [ea delete. ^ true]].

	^ false! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 8/12/2014 14:36'!
hitBox

	^ self bounds! !

!SpriteTrajectory class methodsFor: 'instance creation' stamp: 'spfa 8/12/2014 14:28'!
horizontalAt: aNumber

	^ self vertices: {-50@aNumber . (World width + 50)@aNumber}
		curve: false closed: false! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 9/15/2014 11:46'!
inLevelAfter: aNumber do: aBlock

	| thisLevel uid |

	thisLevel := level.
	uid := level ifNotNil: [level uid].

	([(self currentLevel == thisLevel
		and: [thisLevel isNil or: [thisLevel uid = uid]]
		and: [SpriteGame hasRunningGame]) ifTrue: aBlock] future: (aNumber * 1000))
	value! !

!SpriteGame methodsFor: 'UI' stamp: 'spfa 8/14/2014 12:51'!
inform: aString for: aNumber

	^ self inform: aString for: aNumber height: 40 color: Color red borderColor: Color yellow
! !

!SpriteGame methodsFor: 'UI' stamp: 'spfa 8/14/2014 12:54'!
inform: aString for: aNumber height: hNumber color: aColor borderColor: bColor

	^ self inform: aString for: aNumber height: hNumber color: aColor borderColor: bColor offset: 0@0! !

!SpriteGame methodsFor: 'UI' stamp: 'spfa 8/14/2014 12:53'!
inform: aString for: aNumber height: hNumber color: aColor borderColor: bColor offset: aPoint

	| dm |

	dm := TTFLiveInfo new string: aString;
			font: self bannerFont;
			color: aColor;
			borderColor: bColor;
			borderWidth: 20.

	dm extentHeight: hNumber.

	(dm center: World center + aPoint; lifeTime: aNumber) openInWorld.

	^ dm
! !

!SpriteGame methodsFor: 'key bindings' stamp: 'spfa 9/20/2014 10:33'!
initialKeyBindings

	^ {
		self keyBindingCharacter -> #interactivelyChangeKey. 
		$!! -> #toggleSilentMode.
		27 -> #uninstall.
		$? -> #displayCredits
	}! !

!PlayerHalo methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
initialize

	super initialize.
	self extent: 60 @ 60.! !

!Sprite methodsFor: 'initialization' stamp: 'spfa 9/1/2014 14:41'!
initialize

	owner := nil.
	submorphs := Array empty.
	color := self defaultColor.
	bounds := -1050@ -1050 corner:  -1000@ -1000. "out of the World"
	clock := nextSwapTime := Time millisecondClockValue.
	clockOffset := 0.

	self beSticky! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 8/14/2014 10:52'!
initialize

	self initializeControls! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 8/16/2014 11:40'!
initialize

	super initialize.
	allowHelp := true.
	endCode := [].
	stats := nil.
	uid := self uid + 1.
! !

!SpriteGameScores methodsFor: 'as yet unclassified' stamp: 'spfa 8/15/2014 10:36'!
initialize
	
	scores := Set new! !

!TTFLiveInfo methodsFor: 'as yet unclassified' stamp: 'spfa 7/22/2014 15:38'!
initialize

	super initialize.
	dalpha := 0.03! !

!SpriteGame methodsFor: 'key bindings' stamp: 'spfa 8/14/2014 12:14'!
initializeControls

	Controls ifNotNil: [controls := Controls. ^ self].

	controls := IdentityDictionary new.

	self initialKeyBindings do: [:ea |
		controls at: (ea key isInteger ifTrue: [ea  key] ifFalse: [ea key asciiValue]) 
			put: ea value].
! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 7/18/2014 18:32'!
initializeNewLevel

	Smalltalk garbageCollectMost.! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 9/19/2014 20:47'!
install

	self initializeControls.

	World submorphs do:[:m| m visible: false].
	World displayWorldSafely.
	
	World setProperty: #cachedEventHandler toValue: World eventHandler.

	World eventHandler: EventHandler new.
	World eventHandler on: #keyStroke send: #keyStroke: to: self.
	World eventHandler on: #click send: #click: to: self.
	World eventHandler on: #mouseDown send: #unwantedEvent: to: self.
	World eventHandler on: #mouseMove send: #unwantedEvent: to: self.
	World eventHandler on: #mouseStillDown send: #unwantedEvent: to: self.
	World eventHandler on: #mouseUp send: #unwantedEvent: to: self.
	World eventHandler on: #doubleClick send: #unwantedEvent: to: self.
	World eventHandler on: #startDrag send: #unwantedEvent: to: self.
	World eventHandler on: #doubleClick send: #unwantedEvent: to: self.

	ActiveHand releaseKeyboardFocus.
	Preferences enable: #mouseOverForKeyboardFocus.
	Preferences enable: #noviceMode.

	Project current showWorldMainDockingBar: false. 

	self installDisplay.

	Smalltalk at: #RunningSpriteGame put: self.

	self bannerFont.

	"tmp: increase heap growth ratio at which to do a global GC"
"	Smalltalk vmParameterAt: 55 put: 5.0."

	SoundPlayer stopSoundWhenDone: false.
	SoundPlayer startUp.

! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 9/19/2014 20:48'!
installDisplay

	"The game is full-screen by default, but can instead appear in a window of a definite extent if global WindowedSpriteGame exists"

	(Smalltalk includesKey: #WindowedSpriteGame)
		ifFalse: [Project current fullScreenOn]
		ifTrue: [	| rect |
			rect := Smalltalk at: #WindowedSpriteGame.
			DisplayScreen depth: 32 width: rect x height: rect y fullscreen: false.
			DisplayScreen checkForNewScreenSize].

	Smalltalk at: #RunningSpriteGame put: self.
! !

!SpriteGame methodsFor: 'key bindings' stamp: 'spfa 8/21/2014 11:24'!
interactivelyChangeKey

	self pause; 
		hideHelp; 
		displayKeyBindings;
		write: 'Type a key, ', self keyBindingCharacter, ' finish, ', self keyBindingResetCharacter, ' reset, * click.'onNextKeyDo: [:evt | self changeKey: evt].! !

!SpriteGameScores methodsFor: 'as yet unclassified' stamp: 'spfa 8/18/2014 16:31'!
isGoodScore: anInteger

	^ (scores anySatisfy: [:ea | anInteger perform: self order with: ea value]) 
		or: [scores size < self sizeLimit]! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
isOver

	code ifNotNil: [^ false].
	^ endTest value
! !

!SpriteGame class methodsFor: 'as yet unclassified' stamp: 'spfa 8/16/2014 11:52'!
isSilent

	^ Silent ifNil: [Silent := false]! !

!Morph methodsFor: '*Sprite' stamp: 'spfa 9/4/2014 16:33'!
isSprite

	^ false! !

!Sprite methodsFor: 'testing' stamp: 'spfa 9/4/2014 16:33'!
isSprite

	^ true! !

!Character methodsFor: '*Sprite' stamp: 'spfa 8/14/2014 12:25'!
justifiedUppercaseName

	| un |

	un := self uppercaseName.

	^ un, (String new: 'BACKSPACE' size - un size withAll: $ )! !

!SpriteGame methodsFor: 'key bindings' stamp: 'spfa 8/14/2014 12:45'!
keyBindingCharacter

	^ $$! !

!SpriteGame methodsFor: 'key bindings' stamp: 'spfa 8/17/2014 13:38'!
keyBindingResetCharacter

	^ $!!! !

!SpriteGame methodsFor: 'key bindings' stamp: 'spfa 8/16/2014 14:06'!
keyFor: aSymbol

	^ (Character codePoint: (controls keyAtValue: aSymbol)) uppercaseName! !

!SpriteGame methodsFor: 'key bindings' stamp: 'spfa 8/14/2014 12:14'!
keyStroke: anEvent

	anEvent wasHandled: true.

	self perform: (self controls at: anEvent keyCharacter asUppercase asciiValue ifAbsent: [^ self])
! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
label

	^ label ! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
label: aString

	label := aString! !

!LiveInfo methodsFor: 'as yet unclassified' stamp: 'spfa 7/28/2014 18:07'!
lifeTime: aNumber

	([self delete] future: (aNumber * 1000)) value! !

!TTFLiveInfo methodsFor: 'as yet unclassified' stamp: 'spfa 7/22/2014 15:38'!
lifeTime: aNumber

	"fade in for nSteps, fade out for nSteps"

	| nSteps |

	nSteps := aNumber * 1000 /// self stepTime * 0.5.
	dalpha := nSteps reciprocal
! !

!SpriteTrajectory methodsFor: 'sprite actions' stamp: 'spfa 9/4/2014 16:33'!
loop: nNumber of: aSpriteSubClass speed: aNumber offset: bNumber

	1 to: nNumber do: [:i |
		self loopSprite: (aSpriteSubClass new clockOffset: i * bNumber) speed: aNumber]! !

!SpriteTrajectory methodsFor: 'sprite actions' stamp: 'spfa 9/4/2014 16:33'!
loopSprite: aSprite speed: aNumber

	(aSprite action: (self loopingAtSpeed: aNumber)) openInWorld! !

!SpriteTrajectory methodsFor: 'sprite actions' stamp: 'spfa 9/4/2014 16:33'!
loopingAtSpeed: aNumber

	"aNumber is the speed in pixels per second"

	^ [:sprite :t |
		sprite center: (self pointAtRelativePosition: (t * aNumber /// self totalLength) fractionPart)]
! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 8/16/2014 11:33'!
looseGame

	self inform: 'GAME OVER' for: 10 height: 80 color: Color red borderColor: Color yellow.

	self inLevelAfter: 5 do: [self showHallOfFame]
! !

!Form methodsFor: '*Sprite' stamp: 'spfa 9/14/2014 16:52'!
magnifySpriteBy: scale 

        | newForm rect |
	  rect := self boundingBox.
        newForm := self blankCopyOf: rect scaledBy: scale.
        (WarpBlt toForm: newForm)
                sourceForm: self;
                cellSize: 1;  "installs a new colormap if cellSize > 1"
                combinationRule: 3;
                copyQuad: rect innerCorners toRect: newForm boundingBox.
        ^ newForm! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 8/17/2014 18:13'!
newLevel: aSpriteGameLevel

	(level := aSpriteGameLevel) ifNil: [^ self winGame].

	self initializeNewLevel; perform: level selector.
	level skip ifTrue: [^ self skipRecordStats; newLevel: level nextLevel].
	self signalLevel: level.

	self after: 1 do: [level ifNotNil: [self startNewLevel]].
	self after: 3 do: [self watch]! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
nextLevel

	^ nextLevel! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
nextLevel: aSpriteGameLevel

	nextLevel := aSpriteGameLevel! !

!SpriteTrajectory methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
offset

	^ offset ifNil: [offset := 0@0]! !

!SpriteTrajectory methodsFor: 'as yet unclassified' stamp: 'spfa 7/28/2014 13:09'!
offset: aPoint

	offset := self offset + aPoint! !

!SpriteGameScores methodsFor: 'as yet unclassified' stamp: 'spfa 8/18/2014 16:32'!
onePlayerLimit

	^ 3! !

!LiveInfo methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
openInWorld

	self openInWorldFast
! !

!Sprite methodsFor: 'private' stamp: 'spfa 9/4/2014 16:33'!
openInWorld
	"Much faster than super implementation"

	self openInWorldFast! !

!TTFLiveInfo methodsFor: 'as yet unclassified' stamp: 'spfa 7/22/2014 15:38'!
openInWorld

	self openInWorldFast
! !

!Morph methodsFor: '*Sprite' stamp: 'spfa 8/2/2014 17:51'!
openInWorldFast

	owner ifNotNil: [^ self].

	World addMorph: self.
	World unsafelyStartStepping: self.
	self lock: true! !

!Sprite class methodsFor: 'deprecated' stamp: 'spfa 9/16/2014 20:40'!
orbitingAround: aPoint at: aNumber speed: bNumber

	^ self new action: [:sprite :t |
		sprite center: aPoint + (Point r: aNumber degrees: t \\ 360 * bNumber)]! !

!SpriteGameScores methodsFor: 'as yet unclassified' stamp: 'spfa 8/18/2014 16:28'!
order

	^ #<! !

!SpriteGameScores methodsFor: 'as yet unclassified' stamp: 'spfa 8/18/2014 16:29'!
orderedScores

	^ scores asArray sortBy: [:s1 :s2 | s1 value perform: self order with: s2 value]! !

!Sprite methodsFor: 'private' stamp: 'spfa 9/4/2014 16:33'!
outerBounds

	^ bounds! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 8/16/2014 11:52'!
play: aSound

	SpriteGame isSilent ifTrue: [^ self].

	(aSound ifNil: [^ self]) copy play
! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 9/4/2014 16:33'!
playLevels: anArray

	| nea |

	nea := nil.

	anArray reverseDo: [:ea |
		nea := SpriteGameLevel new selector: ea; 
			label: (self class firstPrecodeCommentFor: ea);
			nextLevel: nea].

	self startAtLevel: nea 
		! !

!SpriteTrajectory methodsFor: 'updating' stamp: 'spfa 9/4/2014 16:33'!
pointAtRelativePosition: aFloat

	| n |

	n := (aFloat * 1000) truncated.

	^ (cache at: n ifAbsentPut: [(self computePointAtRelativePosition: aFloat) rounded]) 
		+ self offset
! !

!Sprite class methodsFor: 'caching' stamp: 'spfa 9/4/2014 16:33'!
populateCache

	FormsCache := IdentityDictionary new.
	self allSubclasses do: [:ea | ea new]! !

!SpriteTrajectory methodsFor: 'updating' stamp: 'spfa 9/4/2014 16:33'!
populateCache

	(0 to: 1000) do: [:n | self pointAtRelativePosition: n / 1000.0]
! !

!SpriteTrajectory class methodsFor: 'caching' stamp: 'spfa 8/4/2014 21:48'!
populateCaches

	self eraseCache.

	(Saucers class methodsInCategory: 'trajectories library') do: [:ea |
		self cache at: ea put: (Saucers perform: ea) populateCache]! !

!SpriteTrajectory methodsFor: 'geometry' stamp: 'spfa 9/4/2014 16:33'!
position: aPoint

	super position: aPoint.
	self eraseCache! !

!SpriteInfo methodsFor: 'as yet unclassified' stamp: 'spfa 9/12/2014 15:45'!
prerequisitePackages
	"These are the names of packages that get loaded before the main change set"
	^#('People-spfa-utils-base1') ! !

!SpriteStandaloneInfo methodsFor: 'as yet unclassified' stamp: 'spfa 9/1/2014 14:24'!
prerequisitePackages
	"These are the names of packages that get loaded before the main change set"
	^#('SpriteExtensions') ! !

!ImageReadWriter class methodsFor: '*Sprite' stamp: 'spfa 9/20/2014 14:18'!
putForm: aForm overFileNamed: fileName
	"Store the given form on a file of the given name, even if it already exists."

	| writer |
	writer := self on: (FileStream fileNamed: fileName) binary.
	Cursor write showWhile: [writer nextPutImage: aForm].
	writer close.
! !

!SpriteInfo methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
readmeText

	^ ''! !

!SpriteStandaloneInfo methodsFor: 'as yet unclassified' stamp: 'spfa 9/1/2014 14:16'!
readmeText

	^ ''! !

!SpriteGameScores methodsFor: 'as yet unclassified' stamp: 'spfa 8/18/2014 16:32'!
register: anAssociation

	| skey dsel |

	dsel := self order == #< ifTrue: [#detectMax:] ifFalse: [#detectMin:].

	anAssociation key ifEmpty: [^ self].
	scores add: anAssociation.

	skey := scores select: [:ea | ea key == anAssociation key].
	skey size > self onePlayerLimit 
		ifTrue: [scores remove: (skey perform: dsel with: [:ea | ea value])].

	scores size > self sizeLimit ifFalse: [^ self].
	scores remove: (scores perform: dsel with: [:ea | ea value])! !

!SpriteGame methodsFor: 'scoring' stamp: 'spfa 8/15/2014 10:42'!
registerScore: score at: aString

	World eventHandler on: #keyStroke send: #keyStroke: to: self.
	self class scores register: aString -> score.

	self showHallOfFame! !

!SpriteInfo class methodsFor: 'as yet unclassified' stamp: 'spfa 8/17/2014 20:03'!
release

	SARPackageDumper fileOutPackage: SpriteInfo new as: 'Sprite.sar'! !

!SpriteStandaloneInfo class methodsFor: 'as yet unclassified' stamp: 'spfa 9/1/2014 14:16'!
release

	SARPackageDumper fileOutPackage: SpriteInfo new as: 'Sprite.sar'! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 8/2/2014 16:09'!
resetChain

	self initialize.
	nextLevel ifNotNil: [nextLevel resetChain]
! !

!Sprite methodsFor: 'initialization' stamp: 'spfa 7/18/2014 22:43'!
resetClock

	clock := Time millisecondClockValue.
	! !

!Form methodsFor: '*Sprite' stamp: 'spfa 9/4/2014 16:33'!
rotateSpriteBy: deg
	"Rotate the receiver by the indicated number of degrees and magnify. scale can be a Point to make for interesting 3D effects "
	"rot is the destination form, big enough for any angle."

	| side rot warp r1 pts bigSide |
	side := 1 + self extent r asInteger.
	bigSide := side asPoint.
	rot := self blankCopyOf: self boundingBox scaledBy: ( bigSide /// self extent ).
	warp := (WarpBlt toForm: rot)
		sourceForm: self;
		cellSize: 1;  "installs a new colormap if cellSize > 1"
		combinationRule: Form over.
	r1 := (0@0 extent: side@side) align: (side@side)//2 with: self boundingBox center.

	"Rotate the corners of the source rectangle." 
	pts := r1 innerCorners collect:
		[:pt | | p |
		p := pt - r1 center.
		(r1 center x asFloat + (p x asFloat*deg degreeCos) + (p y asFloat*deg degreeSin)) @
		(r1 center y asFloat - (p x asFloat*deg degreeSin) + (p y asFloat*deg degreeCos))].
	warp copyQuad: pts toRect: rot boundingBox.
	^ rot
"
 | a f |  f := Form fromDisplay: (0@0 extent: 200@200).  a := 0.
[Sensor anyButtonPressed] whileFalse:
	[((Form fromDisplay: (Sensor cursorPoint extent: 130@66))
		rotateBy: (a := a+5) magnify: 0.75@2 smoothing: 2) display].
f display
"! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 9/4/2014 16:33'!
rotationSpeed

	"in degrees per second"

	^ 0! !

!SpriteGame class methodsFor: 'as yet unclassified' stamp: 'spfa 9/15/2014 11:46'!
runningGame

	^ Smalltalk at: #RunningSpriteGame ifAbsent: [nil]! !

!SampledSound methodsFor: '*Sprite' stamp: 'spfa 8/3/2014 23:20'!
samples: aSoundBuffer

	samples := aSoundBuffer! !

!SpriteTrajectory methodsFor: 'as yet unclassified' stamp: 'spfa 7/28/2014 13:10'!
sansOffset

	offset := 0@0! !

!PasteUpMorph methodsFor: '*Sprite' stamp: 'spfa 9/15/2014 10:52'!
saucersSpriteDo: aBlock

	self submorphsDo: [:m |
		(m isSprite and: [m isSaucersSprite] and: [m visible]) ifTrue: [aBlock value: m]]! !

!PasteUpMorph methodsFor: '*Sprite' stamp: 'spfa 9/15/2014 10:53'!
saucersSprites

	^ self submorphs select: [:m |
		m isSprite and: [m isSaucersSprite] and: [m visible]]! !

!SpriteGame class methodsFor: 'as yet unclassified' stamp: 'spfa 8/15/2014 09:59'!
scores

	^ Scores ifNil: [Scores := SpriteGameScores new]! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
selector

	^ levelSelector! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
selector: aSymbol

	levelSelector := aSymbol! !

!SpriteGame methodsFor: 'scoring' stamp: 'spfa 8/17/2014 19:59'!
showHallOfFame

	| colors tm scores |

	colors := {Color turquoise2 . Color royalBlue} cyclicGenerator.
	
	tm := self inform: 'Hall Of Fame'
		for: Float infinity height: 50 color: Color yellow borderColor: Color orange
		offset: 0@ -8 * 40.

	(scores := self class scores orderedScores) doWithIndex: [:ea :n |
		| line col |
		col := colors next.
		line := self inform: ea value asString
			for: Float infinity height: 40 color: col borderColor: Color red
			offset: 0@((n - 5) * 50).
		line left: tm left - 0.
		line := self inform: ea key
			for: Float infinity height: 40 color: col borderColor: Color red
			offset: 0@((n - 5) * 50).
		line right: tm right].

	scores ifNotEmpty: [^ self].

	self inform: 'There has been no victorious ones yet ...'
		for: Float infinity height: 30 color: Color royalBlue borderColor: Color red
		offset: 0@(-6 * 40)
	
	
! !

!SpriteGame methodsFor: 'scoring' stamp: 'spfa 9/20/2014 11:01'!
showScore

	| score |

	SpriteGame hasRunningGame ifFalse: [^ self].

	score := root computeScore rounded.

	(self class scores isGoodScore: score) 
		ifTrue: [self inLevelAfter: 1 do: [self getPlayerNameForScore: score]]
		ifFalse: [self inLevelAfter: 3 do: [self showHallOfFame]].

	self inform: 'Completed in ', score, ' seconds.' 
		for: 20 height: 50 color: Color green borderColor: Color yellow
		offset: 0@200
! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 8/14/2014 12:55'!
signalLevel: aSpriteGameLevel

	"tmp"

	self inform: (aSpriteGameLevel label ifNil: ['NEW LEVEL'])
		for: 10 height: 40 color: Color turquoise borderColor: Color blue
! !

!SpriteGame class methodsFor: 'as yet unclassified' stamp: 'spfa 8/16/2014 11:53'!
silent: aBoolean

	Silent := aBoolean! !

!SpriteGameScores methodsFor: 'as yet unclassified' stamp: 'spfa 8/18/2014 16:31'!
sizeLimit

	^ 10! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 7/28/2014 14:33'!
skip

	^ (skipTest ifNil: [^ false]) value! !

!SpriteGame methodsFor: 'scoring' stamp: 'spfa 7/28/2014 14:37'!
skipRecordStats

	self beginRecordStats.
	level stats at: #skipped put: true.
	self endRecordStats.! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 7/28/2014 14:33'!
skipTest: aBlock

	skipTest := aBlock! !

!SpriteTrajectory methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
smoothCurve: aBoolean

	smoothCurve := aBoolean.
	self changed; computeBounds! !

!SpriteTrajectory class methodsFor: 'instance creation' stamp: 'spfa 8/12/2014 14:28'!
somewhatHorizontalAt: aNumber

	^ self vertices: {-50@(aNumber +- 50) . (World width + 50)@(aNumber +- 50)}
		curve: false closed: false! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
start

	self code value.
	code := nil "triggers the end test"! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 8/2/2014 15:05'!
startAtLevel: aSpriteGameLevel

	root := aSpriteGameLevel.
	
	self checkUpResources; install; newLevel: aSpriteGameLevel.
! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 7/18/2014 18:35'!
stats

	^ stats ifNil: [stats := IdentityDictionary new]! !

!Sprite methodsFor: 'stepping' stamp: 'spfa 9/16/2014 21:05'!
step

	| sc t mt rect |

	t := self timeNow.

	rect := self fullBounds.

	(forms isNil or: [nextSwapTime > (mt := Time millisecondClockValue)])
		ifFalse: [
			(self growsAtBirth and: [(sc := t * self growthRate) < 1.2]) 
				ifTrue: [self form: (forms next magnifySpriteBy: (sc min: 1.0))]
				ifFalse: [self form: forms next] .
			self rotationSpeed isZero ifFalse: [ | angle |
				angle := (t * self rotationSpeed) truncated.
				angle > 0 ifTrue: [self form: (form rotateSpriteBy: angle)]].
			nextSwapTime := mt + self swapDelay].

	action ifNil: [^ t].

	action value: self value: t + clockOffset.

	World invalidRect: (rect expandBy: 50) from: World.

	^ t
	
	
! !

!TTFLiveInfo methodsFor: 'as yet unclassified' stamp: 'spfa 7/22/2014 15:40'!
step

	self color: (self color alpha: self color alpha + dalpha).
	self borderColor: (self borderColor alpha: self borderColor alpha + dalpha).
	self color alpha >= 1.0 ifTrue: [dalpha := dalpha negated].
	self color alpha <= 0.0 ifTrue: [self delete].! !

!Sprite methodsFor: 'stepping' stamp: 'spfa 9/15/2014 10:42'!
stepTime

	^ 20  "(50 / 1000.0) reciprocal"
	! !

!TTFLiveInfo methodsFor: 'as yet unclassified' stamp: 'spfa 7/28/2014 18:10'!
stepTime

	^ 60
! !

!SpriteTrajectory methodsFor: 'printing' stamp: 'spfa 7/18/2014 20:28'!
storeOn: aStream

	aStream nextPutAll: self class name;
		nextPutAll: ' vertices: '.

	(vertices collect: #asIntegerPoint) printOn: aStream.

	aStream nextPutAll: ' curve: '. smoothCurve storeOn: aStream.
	aStream nextPutAll: ' closed: '. closed storeOn: aStream.
! !

!SpriteGame class methodsFor: 'as yet unclassified' stamp: 'spfa 7/23/2014 09:24'!
strikeFont20	

	^ self strikeFont: 20! !

!SpriteGame class methodsFor: 'as yet unclassified' stamp: 'spfa 7/23/2014 09:23'!
strikeFont30	

	^ self strikeFont: 30! !

!SpriteGame class methodsFor: 'as yet unclassified' stamp: 'spfa 7/23/2014 09:33'!
strikeFont: anInteger

	^ self strikeFonts at: anInteger ifAbsentPut:
		[self bannerFont asStrikeFontScale: anInteger /// self bannerFont fontHeight]
! !

!SpriteGame class methodsFor: 'as yet unclassified' stamp: 'spfa 7/23/2014 09:21'!
strikeFonts

	^ CustomStrikeFont ifNil: 
		[CustomStrikeFont := IdentityDictionary new]
! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 9/2/2014 09:56'!
swapDelay

	^ swapInterval ifNil: [swapInterval := self defaultSwapDelay]
	
	
! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 9/2/2014 09:56'!
swapDelay: anInteger

	swapInterval := anInteger
	
	
! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 9/4/2014 16:33'!
timeNow

	^ (Time millisecondsSince: clock) / 1000.0! !

!Sprite methodsFor: 'behavior' stamp: 'spfa 9/15/2014 00:22'!
timeNowWithOffset

	^ self timeNow + clockOffset! !

!SpriteGame methodsFor: 'UI' stamp: 'spfa 8/16/2014 11:55'!
toggleSilentMode

	self class silent: self class isSilent not! !

!SpriteTrajectory methodsFor: 'updating' stamp: 'spfa 9/4/2014 16:33'!
totalLength

	^ cache at: #totalLength ifAbsentPut: [self computeTotalLength]
! !

!SpriteGameLevel methodsFor: 'as yet unclassified' stamp: 'spfa 8/16/2014 11:39'!
uid

	^ uid ifNil: [0]! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 9/20/2014 11:14'!
uninstall

	level := nil.

	Smalltalk removeKey: #RunningSpriteGame.

 	Project current fullScreenOff.

	(Smalltalk includesKey: #WindowedSpriteGame) ifTrue: [
		| rect |
		rect := Smalltalk at: #CachedExtentForWindowedSpriteGame.
		DisplayScreen depth: 32 width: rect x height: rect y fullscreen: false.
		DisplayScreen checkForNewScreenSize].

	World submorphs do:[:m| m visible ifTrue: [m delete]].
	World submorphs do:[:m| m visible: true].

	World eventHandler: (World valueOfProperty: #cachedEventHandler).
	World removeProperty: #cachedEventHandler.
	
	Preferences disable: #mouseOverForKeyboardFocus.

	World activeHand showTemporaryCursor: nil.

	SoundPlayer stopSoundWhenDone: true.

! !

!PasteUpMorph methodsFor: '*Sprite' stamp: 'spfa 7/18/2014 16:46'!
unsafelyStartStepping: aMorph
	
	worldState unsafelyStartStepping: aMorph! !

!WorldState methodsFor: '*Sprite' stamp: 'spfa 7/18/2014 16:38'!
unsafelyStartStepping: aMorph 
	"Add the given morph to the step list. Do NOT perform any safety test."

	self adjustWakeupTimesIfNecessary.
	stepList add:(
		StepMessage 
			scheduledAt: Time millisecondClockValue
			stepTime: nil
			receiver: aMorph
			selector: #step
			arguments: nil)! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 7/22/2014 17:22'!
unwantedEvent: evt
! !

!Character methodsFor: '*Sprite' stamp: 'spfa 8/14/2014 12:25'!
uppercaseName

	^ ((Character constantNameFor: self) ifNil: [self asString]) asUppercase! !

!SpriteTrajectory class methodsFor: 'instance creation' stamp: 'spfa 8/12/2014 16:10'!
verticalAt: aNumber

	^ self vertices: {aNumber@ -50 . aNumber@(World height + 50)}
		curve: false closed: false! !

!SpriteTrajectory class methodsFor: 'instance creation' stamp: 'spfa 8/16/2014 12:55'!
vertices: anArray

	^ self vertices: anArray curve: true closed: false! !

!SpriteTrajectory methodsFor: 'as yet unclassified' stamp: 'spfa 9/4/2014 16:33'!
vertices: anArray curve: cFlag closed: dFlag

	smoothCurve := cFlag.
	closed := dFlag.
	self setVertices: anArray! !

!SpriteTrajectory class methodsFor: 'instance creation' stamp: 'spfa 9/4/2014 16:33'!
vertices: anArray curve: cFlag closed: dFlag

	^ self new fillStyle: Color transparent; vertices: anArray curve: cFlag closed: dFlag! !

!Sprite methodsFor: 'stepping' stamp: 'spfa 9/4/2014 16:33'!
wantsSteps

	^ true! !

!TTFLiveInfo methodsFor: 'as yet unclassified' stamp: 'spfa 7/22/2014 15:38'!
wantsSteps

	^ true! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 8/2/2014 15:05'!
watch

	level ifNil: [^ self].

	self checkForFailure ifTrue: [^ self looseGame].

	self watchForAction.

	level isOver ifTrue: [
		self endRecordStats.
		level endCode value.
		self newLevel: level nextLevel]

	ifFalse: [self after: 2 do: [self watch]].
! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 7/18/2014 16:05'!
watchForAction! !

!SpriteGame methodsFor: 'game flow' stamp: 'spfa 8/21/2014 11:29'!
winGame

	| cheated message |

	cheated := (root anyStatsContains: #replay) or: [root anyStatsContains: #paused].
	message := cheated ifFalse: ['YOU WIN !!'] ifTrue: ['YOU (almost) WIN !!'].

	self inform: message for: 10 height: 100 color: Color green borderColor: Color yellow.

	cheated ifTrue: [^ self inLevelAfter: 3 do: [self showHallOfFame]].
	self inLevelAfter: 2 do: [self showScore]
! !

!SpriteGame class methodsFor: 'as yet unclassified' stamp: 'spfa 7/28/2014 15:24'!
worldOrigin

	^ 0@0! !

!SpriteGame methodsFor: 'UI' stamp: 'spfa 8/15/2014 10:04'!
write: aString onNextKeyDo: aBlock

	| dm |

	dm := self inform: aString for: Float infinity.

	World eventHandler on: #keyStroke send: #value: to: [:evt |
		dm delete. 
		aBlock value: evt].! !

!SpriteGame methodsFor: 'as yet unclassified' stamp: 'spfa 9/20/2014 14:22'!
writeScreenshot

	| screenshot sfname |

	screenshot := World imageForm.
	sfname := FileReference nextNameFor: (self class name, '_screenshot.png').
	sfname asFileReference create.

	[:fnam |
		[PNGReadWriter putForm: screenshot overFileNamed: sfname] 
			forkAt: Processor userBackgroundPriority] value: sfname! !
